#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdint.h>
#include <sys/mman.h>

extern int _code_start();
extern int _code_end();

char* allocMemoryBlock(size_t size, int exec)
{
    void* p = mmap(
        0,
        size,
        PROT_READ | PROT_WRITE | (exec? PROT_EXEC:0),
        MAP_PRIVATE | MAP_ANON,
        -1,
        0
    );

    if (p == MAP_FAILED)
    {
        printf("alloc_machine_code_block: Could not allocate memory");
        exit(1);
    }

    return (char*)p;
}

void freeMemoryBlock(char* code, size_t size)
{
    munmap(code, size);
}

int main(int argc, char *argv[])
{
  char *buf;
  int len;
  char* start = (char*)_code_start;
  char* end = (char*)_code_end;

  len = end - start;

  printf("length = %d\n", len);

  if (atoi(argv[1]) != 0)
    {
      buf = allocMemoryBlock(len, 1);
      memcpy(buf, start, len);
      start = buf;
    }

  printf("%p\n", start);
  printf("0x%x\n", ((int(*)())start)());

  return 0;
}
